type symbol = string
type variable = string
type state = int

type kind = Eq | Rw
type atom = state * state * kind


module Symbol =
struct
  type t = symbol
  let compare = Pervasives.compare
  let to_string s = s
end

module State =
struct
  type t = int

  let compare = Pervasives.compare
  let to_string s = "q" ^ (string_of_int s)
end

module Variable =
struct
  type t = string
  let compare = Pervasives.compare
  let to_string s = s
end

module Epsilon =
struct
  type t = state * state
  let compare = Pervasives.compare

  let to_string (s1, s2) =
    (State.to_string s1) ^ " -> " ^ (State.to_string s2)
end

module Epsiset = Set2.Make(Epsilon)
module StatesSet = Epsiset

module Statelist =
struct
  type t = state list

  let compare = Pervasives.compare

  let to_string =
    List2.to_string ~sep:"," ~left:"" ~right:""
      State.to_string
end

module Stateset = Set2.Make(State)
module StateMap = Map.Make(State)
