(** Definition of verbose level: to decide when messages have to be
    displayed or tasks have to be done *)
let level = ref 0

(** We Actually use Common.verbose global reference instead of [level] *)
let println thresh str =
  if !Common.verbose > thresh then print_string (str () ^ "\n")
    (* For efficiency, we use print_string instead of print_endline
       that consistently flushes the stdout *)

let print thresh str =
  if !Common.verbose > thresh then print_string (str ())

let exec thresh task =
  if !Common.verbose > thresh then task ()


let printf thresh =
  if !Common.verbose > thresh then
    Format.printf
  else
    Format.ifprintf Format.std_formatter
